
-- Parametres globaux
gPluginName="KikiItem";
gDebug = {};

-- Import 
import "Turbine";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";

import "Kiki.Commons.Trace";
import "Kiki.Commons.UTF";
import "Kiki.Commons.Class";
import "Kiki.Commons.Tools";
import "Kiki.Commons.Settings";
import "Kiki.Commons.Tooltips";
import "Kiki.Commons.Onscreen";
import "Kiki.KikiItem.Languages";

-- Charge les traductions
gLanguage = getClientLanguage();
gLang = getLang(gLanguage); 

-- Joueur
gPlayer = Turbine.Gameplay.LocalPlayer.GetInstance();
gPlayerName = gPlayer:GetName();


-- main window
import "Kiki.KikiItem.wItem";

-- Function de dechargment du plugin
Plugins[gPluginName].Unload = function(self,sender,args)
	wItem:Unload();
	Kiki.Commons.Trace("unloaded");
end

-- commande /item
scCommand = Turbine.ShellCommand();
Turbine.Shell.AddCommand(gLang.COMMAND, scCommand);
function scCommand:GetShortHelp()
    return gLang.USAGE;
end
function scCommand:GetHelp()
    return self:GetShortHelp();
end

capture = true;
function scCommand:Execute(cmd, args)
	-- Kiki.Commons.Trace("Item:"..args);
	if args=="on" then
		capture = true;
		Kiki.Commons.Trace(gLang.TRACKON);
	elseif args=="off" then
		capture = true;
		Kiki.Commons.Trace(gLang.TRACKOFF);
	elseif args=="clear" then
		wItem:ClearItems();
	elseif args=="save" then
		wItem:SaveItems();
	elseif string.sub(args,1,5) == "scan " then
		local i,j = string.match(args,"(%d+) (%d+)",6);
		if i == nil then
			Kiki.Commons.Trace(gLang.BADARGS);
		else
			wItem:ScanGame(tonumber(i),tonumber(j));
		end
	else
		wItem:SetVisible(true);
		wItem:Activate();
	end
end

-- tracking des infos dans les channels de chat
-- en particulier les sequences magiques ^^
Turbine.Chat.Received = function (sender, args)
	-- prevent recursive calls, si mode non capture, ou pas de message
	if chatInProc == true or capture~=true or args.Message == nil then return; end
	
	chatInProc = true;
	
	-- local msg = string.gsub(args.Message,"(<)","!");
	-- Kiki.Commons.Trace(msg);
	
	if string.find(args.Message,"<Examine",1,true) then
		-- Match les trucs connus !
		for hex,text in string.gmatch(args.Message, "Examine:IIDDID:0x0000000000000000:0x(%x+)>(%b[])") do
			-- Ajoute dans la table des objets connus !
			wItem:AddReference(hex,text);
		end
		for hex,text in string.gmatch(args.Message, "ExamineItemInstance:ItemInfo:([^>]+)>(%b[])") do
			-- Les elements ExamineItemInstance, je ne sais pas parser la chaine binaire....
			-- Converison en HEXA de la chaine d'info
			-- local hexStr = "";
			-- for i=1, #hex do
			--	hexStr = hexStr .. string.format("%02X",string.byte(hex,i));
			-- end
			-- Kiki.Commons.Trace(gLang.IGNORED..hexStr.."="..text); 
			Kiki.Commons.Trace(gLang.IGNORED.."<rgb=#FF0000>"..text.."</rgb>"); 
		end
	end
	chatInProc = false;
end

-- Retrouve la version du plugin
Kiki.Commons.Trace("loaded (version ".. Plugins[gPluginName]:GetVersion() .. " by Kikiadoc@Sirannon)");
Kiki.Commons.Trace(gLang.USAGE);
Kiki.Commons.Trace(gLang.FILE.. "<<document>>\\The Lord of the Rings Online\\PluginData\\<<loginName>>\\<<ServerName>>\\AllCharacters\\KikiItem_panel.plugindata");












